#!/usr/bin/perl
my ($arg1) = @ARGV;
@Files;

open(FILE, '<'.$arg1);
my @fconts = <FILE>;
close(FILE);

map(s/\n//gis, @fconts);
my %Messages = ();
my %MessagesNum = ();
my %MessageAliases = ();
my %MessagesDesc = ();
my %HeaderList = ();
my %HeaderMessageMap = ();
my $output = '';
my $headers = '';
my $header = '';

foreach(@fconts)
{
  unless ($_ =~ /^\/\//)
  {
    if ($_ =~ /^\s*#define\s+?((?:ABM|ACM|ACN|BCM|BM|BN|CB|CBEM|CBEN|CBN|CCM|CDM|CDN|DM|DTM|DTN|EM|EN|FM|HDM|HDN|HKM|ICM|IPM|IPN|LB|LBN|LM|LVM|LVN|MCM|MCN|NM|PBM|PGM|PGN|PSM|RB|RBN|SB|SBM|SBN|STM|STN|TB|TBM|TBN|TCM|TCN|TTM|TTN|TVN|UDM|UDN|WM)_.+?)[\s\t]+?(.+?)$/i)
    {
      push(@{$Messages{$1}}, CleanDef($2));
      $HeaderMessageMap{$1} = $header;
    }
  }
  elsif(m/\/\/\s+\[.+?([^\/\\]+\.h)]/i)
  {
    $_ =~ s/\/\/\s+\[.+?([^\/\\]+\.h)]/$1/i;
    if(lc($header) ne lc($_))
    {
      $header = $_;
      $HeaderList{$header} = 1;
      $headers .= "\t<$header>\n";
    }
  }
}

$headers = '/* Headers included in this list ...

'.$headers.'
*/
';

# First determine all hardcoded messages as some of the other messages are
# based on these hardcoded ones
foreach $msg (sort keys %Messages)
{
  foreach $val (sort @{$Messages{$msg}})
  {
    if($val =~ /^0x[0-9A-F]+$/i) # Hexadecimal values ...
    {
       push(@{$MessagesNum{$msg}}, eval($val));
       $val = '';
    }
    elsif($val =~ /[0-9]+/i) # Decimal values ...
    {
       push(@{$MessagesNum{$msg}}, eval($val));
       $val = '';
    }
    elsif($val =~ /^[0-9A-Fx+-]+$/i) # Some kind of calculated value (hardcoded)
    {
       push(@{$MessagesNum{$msg}}, eval($val));
       $val = '';
    }
  }
}

foreach $msg (sort keys %Messages)
{
  foreach $val (sort @{$Messages{$msg}})
  {
    if($val ne '')
    {
      if($val =~ /^(.+?)[+-](.+?)$/i) # Messages based on hardcoded ones
      {
        $one = $1;
        $two = $2;
        if((exists $MessagesNum{$one}) || (exists $MessagesNum{$two}))
        {
          my $s = $val;
          foreach $key (@{$MessagesNum{$one}})
          {
            $s =~ s/$one/$key/gism;
          }
          foreach $key (@{$MessagesNum{$two}})
          {
            $s =~ s/$two/$key/gism;
          }
          if($val ne $s)
          {
            push(@{$MessagesNum{$msg}}, eval($s));
          }
        }
        next; # Next matching item, skip alias handling from here
      }
      # Aliases
      $MessageAliases{$val} .= ' == '.$msg;
    }
  }
}

# Now after we have evaluated all the messages let's create a really big list
foreach $msg (sort keys %MessagesNum)
{
  foreach $val (sort @{$MessagesNum{$msg}}) # Iterate the array
  {
    my $key = sprintf('0x%8.8X', eval($val));
    if($MessageAliases{$msg} ne '')
    {
      my $mystr = $MessageAliases{$msg};
      $mystr =~ s/^[\s\t]+//i;
      $mystr =~ s/[\s\t]+$//i;
      if($msg =~ /^WM_/i)
      {
        $MessagesDesc{$key}{'WM'} .= sprintf("[b]%s (%s)[/b] <%s>\\r\\n", $msg, $mystr, $HeaderMessageMap{$msg});
      }
      elsif($msg =~ /^(?:.+?)N_/i)
      {
        $MessagesDesc{$key}{'NOTIFY'} .= sprintf("%s (%s) <%s>\\r\\n", $msg, $mystr, $HeaderMessageMap{$msg});
      }
      else
      {
        $MessagesDesc{$key}{0} .= sprintf("%s (%s) <%s>\\r\\n", $msg, $mystr, $HeaderMessageMap{$msg});
      }
    }
    else
    {
      if($msg =~ /^WM_/i)
      {
        $MessagesDesc{$key}{'WM'} .= sprintf("[b]%s[/b] <%s>\\r\\n", $msg, $HeaderMessageMap{$msg});
      }
      elsif($msg =~ /^(?:.+?)N_/i)
      {
        $MessagesDesc{$key}{'NOTIFY'} .= sprintf("%s <%s>\\r\\n", $msg, $HeaderMessageMap{$msg});
      }
      else
      {
        $MessagesDesc{$key}{0} .= sprintf("%s <%s>\\r\\n", $msg, $HeaderMessageMap{$msg});
      }
    }
  }
}

#Finally pretty-print the result ...
foreach $key (sort keys %MessagesDesc)
{
  my $val = $MessagesDesc{$key}{'WM'}.$MessagesDesc{$key}{0}.(($MessagesDesc{$key}{'NOTIFY'} eq '') ? '' : '[hr]'.$MessagesDesc{$key}{'NOTIFY'});
  $output .= "\t{ $key, TEXT(\"$val\\0\")},\n";
}

$output = $headers."
struct MAPMSG
{
\tUINT uMsg;
\tLPCTSTR szMsg;
};

static const MAPMSG MessageMap[] =
{
".$output."\t// Declare end \"tag\"
\t{0, NULL}
};

static LPCTSTR szRtfWrap = TEXT(\"{\\\\rtf1\\\\ansi\\\\ansicpg1252\\\\deff0\\\\deflang1033{\\\\fonttbl{\\\\f0\\\\fswiss\\\\fprq2\\\\fcharset0 Arial;}{\\\\f1\\\\fmodern\\\\fprq1\\\\fcharset0 Courier New;}}\\r\\n{\\\\colortbl ;\\\\red255\\\\green0\\\\blue0;\\\\red0\\\\green0\\\\blue0;\\\\red127\\\\green127\\\\blue127;\\\\red0\\\\green0\\\\blue255;}\\r\\n\\\\viewkind4\\\\uc1\\\\pard\\\\cf2\\\\f0\\\\fs18 %s}\\r\\n\\0\");
static LPCTSTR szRtfColorRed = TEXT(\"\\\\cf1\\0\");
static LPCTSTR szRtfColorBlack = TEXT(\"\\\\cf2\\0\");
static LPCTSTR szRtfColorBlackFN = TEXT(\">\\\\fs18\\\\cf2\\0\");
static LPCTSTR szRtfColorGray = TEXT(\"\\\\cf3\\0\");
static LPCTSTR szRtfColorGrayFN = TEXT(\"\\\\cf3\\\\fs16<\\0\");
static LPCTSTR szRtfNewline = TEXT(\"\\\\par\\r\\n\\0\");
static LPCTSTR szRtfBoldStart = TEXT(\"\\\\b \\0\");
static LPCTSTR szRtfBoldEnd = TEXT(\"\\\\b0 \\0\");
static LPCTSTR szRtfHorzRule = TEXT(\"\\\\pard\\\\qc\\\\b __________________________________ \\\\b0\\\\f0\\\\par\\r\\n\\\\pard \");
";

print $output;
exit;

sub CleanDef
{
  my ($str) = @_;
  $str =~ s/\n//gism;
  $str =~ s/[\s\t]*\/\/.+?$//gism;
  $str =~ s/[\s\t]*\/\*.+?$//gism;
  $str =~ s/\s+//gism;
  $str =~ s/\(//gism;
  $str =~ s/\)//gism;
  $str =~ s/^([0-9A-Fx]+?)(?:U|L)?([+-])([0-9A-Fx]+?)(?:U|L)?$/$1$2$3/gism;
  $str =~ s/(?:U|L)$//gism;
  return $str;
}
__END__

